<?php
/**
 * Copyright © Magento, Inc. All rights reserved.
 * See COPYING.txt for license details.
 */
namespace Threepartment\Serialnumbers\Block\Adminhtml\Create;

/**
 * Adminhtml shipment items grid
 *
 * @api
 * @since 100.0.2
 */
class Items extends \Magento\Shipping\Block\Adminhtml\Create\Items
{
    /**
     * Return Serials array
     *
     * @return Array
     */

     /**
     * @var \Magento\Framework\App\ResourceConnection
     */

    
    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\CatalogInventory\Api\StockRegistryInterface $stockRegistry,
        \Magento\CatalogInventory\Api\StockConfigurationInterface $stockConfiguration,
        \Magento\Framework\Registry $registry,
        \Magento\Sales\Helper\Data $salesData,
        \Magento\Shipping\Model\CarrierFactory $carrierFactory,
        \Magento\Framework\App\ResourceConnection $resource,
        array $data = []
        //
    ) {
        $this->_resource = $resource;
        parent::__construct($context, $stockRegistry, $stockConfiguration, $registry, $salesData, $carrierFactory,  $data);
    }
    public function getSerialsBySKU()
    {
        $skus = array();
        $results = array();
        $_items = $this->getShipment()->getAllItems();
        foreach($_items as $_item){
            if ($_item->getOrderItem()->getParentItem()) continue;
            array_push($skus, "'".$_item->getSku()."'");
        }
        $skus = array_unique($skus);
        if(!empty($skus)){
            $skus = implode(',', $skus);
            $tableName = $this->getTableName('threepartment_serialnumbers_serialnumber');
            $query = 'SELECT `serial_number_id`, `sku`, `serial_number` FROM ' . $tableName. " WHERE sku IN ($skus) AND `status`=0";
            $results = $this->_resource->getConnection()->fetchAll($query);
            if(!empty($results)){
                $htmlOptions = array();
                foreach($results as $result){
                    if(isset($htmlOptions['sku_'.$result['sku']])){
                        $htmlOptions['sku_'.$result['sku']] .= '<option value="'.$result['serial_number_id'].'">'.$result['serial_number'].'</option>';
                    }else{
                        $htmlOptions['sku_'.$result['sku']] = '<option value="'.$result['serial_number_id'].'">'.$result['serial_number'].'</option>';
                    }
                }
                $results = $htmlOptions;
            }
        }
        return $results;
    }

    public function getTablename($tableName){
        $connection  = $this->_resource->getConnection();
        $tableName   = $connection->getTableName($tableName);
        return $tableName;
    }
}
