<?php

namespace Threepartment\Serialnumbers\Block\Order\Email\Items\Order;


/**
 * Sales Order Email items default renderer
 *
 * @api
 * @author     Magento Core Team <core@magentocommerce.com>
 * @since 100.0.2
 */
class DefaultOrder extends \Magento\Sales\Block\Order\Email\Items\Order\DefaultOrder
{
    /**
     * @var \Magento\Framework\App\ResourceConnection
     */
    protected $_resource;

    public function __construct(
        \Magento\Backend\Block\Template\Context $context,
        \Magento\CatalogInventory\Api\StockRegistryInterface $stockRegistry,
        \Magento\CatalogInventory\Api\StockConfigurationInterface $stockConfiguration,
        \Magento\Framework\Registry $registry,
        \Magento\Catalog\Model\Product\OptionFactory $optionFactory,
        \Magento\Framework\App\ResourceConnection $resource,
        array $data = []
    ) {
        $this->_resource = $resource;
        parent::__construct($context, $data);
    }

    public function getAssociatedSerialNumbers(){
        $associated_serial = '';
        $order_id = $this->getOrder()->getId();
        $sku = $this->getSku($this->getItem());
        $tableName = $this->getTableName('threepartment_serialnumbers_serialnumber');
        $query = "SELECT GROUP_CONCAT(`serial_number` SEPARATOR ', ') as serial_number FROM `threepartment_serialnumbers_serialnumber` WHERE `order_id` = $order_id AND `sku` = '$sku' GROUP BY `sku`";
        $results = $this->_resource->getConnection()->fetchAll($query);
        foreach($results as $result){
            $associated_serial = $result['serial_number'];
        }
        if(!empty($associated_serial)){
            $associated_serial = __('Serial Number(s)').': '.$associated_serial;
        }
        return $associated_serial;
    }
}
