<?php

namespace Threepartment\Serialnumbers\Controller\Adminhtml\Serialnumber;

use Magento\Framework\Controller\ResultFactory;

class AddRow extends \Magento\Backend\App\Action
{
    /**
     * @var \Magento\Framework\Registry
     */
    private $coreRegistry;

    /**
     * @var \Threepartment\Serialnumbers\Model\SerialnumberFactory
     */
    private $gridFactory;

    /**
     * @param \Magento\Backend\App\Action\Context $context
     * @param \Magento\Framework\Registry $coreRegistry,
     * @param \Threepartment\Serialnumbers\Model\SerialnumberFactory $gridFactory
     */
    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\Registry $coreRegistry,
        \Threepartment\Serialnumbers\Model\SerialnumberFactory $gridFactory
    ) {
        parent::__construct($context);
        $this->coreRegistry = $coreRegistry;
        $this->gridFactory = $gridFactory;
    }

    /**
     * Mapped Grid List page.
     * @return \Magento\Backend\Model\View\Result\Page
     */
    public function execute()
    {
        $rowId = (int) $this->getRequest()->getParam('id');
        $rowData = $this->gridFactory->create();
        /** @var \Magento\Backend\Model\View\Result\Page $resultPage */
        if ($rowId) {
            
            $rowData = $rowData->load($rowId);
            $rowTitle = $rowData->getSerialNumber();
            if (!$rowData->getSerialNumberId()) {
                $this->messageManager->addError(__('row data no longer exist.'));
                $this->_redirect('threepartment_serialnumbers/serialnumber/rowdata');
                return;
            }
        }

        $this->coreRegistry->register('row_data', $rowData);
        $resultPage = $this->resultFactory->create(ResultFactory::TYPE_PAGE);
        $title = $rowId ? __('Edit Serial Number ').$rowTitle : __('Add Serial Number');
        $resultPage->getConfig()->getTitle()->prepend($title);
        return $resultPage;
    }

    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('Threepartment_Serialnumber::add_row');
    }
}
