<?php
namespace Threepartment\Serialnumbers\Model;

use Threepartment\Serialnumbers\Api\Data\SerialInterface;

class Serialnumber extends \Magento\Framework\Model\AbstractModel implements SerialInterface
{
	const CACHE_TAG = 'threepartment_serialnumbers_serialnumber';

	protected $_cacheTag = 'threepartment_serialnumbers_serialnumber';

	protected $_eventPrefix = 'threepartment_serialnumbers_serialnumber';

	protected function _construct()
	{
		$this->_init('Threepartment\Serialnumbers\Model\ResourceModel\Serialnumber');
	}

	/**
     * Get SerialNumberId.
     *
     * @return int
     */
    public function getSerialNumberId()
    {
        return $this->getData(self::SERIAL_NUMBER_ID);
    }

    /**
     * Set SerialNumberId.
     */
    public function setSerialNumberId($entityId)
    {
        return $this->setData(self::SERIAL_NUMBER_ID, $entityId);
	}
	
	/**
     * Get ProductId.
     *
     * @return int
     */
    public function getProductId()
    {
        return $this->getData(self::PRODUCT_ID);
    }

    /**
     * Set ProductId.
     */
    public function setProductId($entityId)
    {
        return $this->setData(self::PRODUCT_ID, $entityId);
	}
	
	/**
     * Get SKU.
     *
     * @return var
     */
    public function getSku()
    {
        return $this->getData(self::SKU);
    }

    /**
     * Set SKU.
     */
    public function setSku($entityId)
    {
        return $this->setData(self::SKU, $entityId);
	}
	
	/**
     * Get SerialNumberId.
     *
     * @return int
     */
    public function getSerialNumber()
    {
        return $this->getData(self::SERIAL_NUMBER);
    }

    /**
     * Set SerialNumber.
     */
    public function setSerialNumber($entityId)
    {
        return $this->setData(self::SERIAL_NUMBER, $entityId);
	}
	
	/**
     * Get Status.
     *
     * @return var
     */
    public function getStatus()
    {
        return $this->getData(self::STATUS);
    }

    /**
     * Set Status.
     */
    public function setStatus($entityId)
    {
        return $this->setData(self::STATUS, $entityId);
	}
	
	/**
     * Get Order ID.
     *
     * @return int
     */
    public function getOrderId()
    {
        return $this->getData(self::ORDER_ID);
    }

    /**
     * Set OrderId.
     */
    public function setOrderId($entityId)
    {
        return $this->setData(self::ORDER_ID, $entityId);
	}
	
	/**
     * Get Date Created.
     *
     * @return var
     */
    public function getDateCreated()
    {
        return $this->getData(self::DATE_CREATED);
    }

    /**
     * Set Date Created.
     */
    public function setDateCreated($entityId)
    {
        return $this->setData(self::DATE_CREATED, $entityId);
	}
	
	/**
     * Get Date Updated
     *
     * @return var
     */
    public function getDateUpdated()
    {
        return $this->getData(self::DATE_UPDATED);
    }

    /**
     * Set Date Updated.
     */
    public function setDateUpdated($entityId)
    {
        return $this->setData(self::DATE_UPDATED, $entityId);
    }
}