<?php

namespace Threepartment\Serialnumbers\Setup;

class InstallSchema implements \Magento\Framework\Setup\InstallSchemaInterface
{

	public function install(\Magento\Framework\Setup\SchemaSetupInterface $setup, \Magento\Framework\Setup\ModuleContextInterface $context)
	{
		$installer = $setup;
		$installer->startSetup();
		if (!$installer->tableExists('threepartment_serialnumbers_serialnumber')) {
			$table = $installer->getConnection()->newTable(
				$installer->getTable('threepartment_serialnumbers_serialnumber')
			)
				->addColumn(
					'serial_number_id',
					\Magento\Framework\DB\Ddl\Table::TYPE_INTEGER,
					null,
					[
						'identity' => true,
						'nullable' => false,
						'primary'  => true,
						'unsigned' => true,
					],
					'Serial Number ID'
				)
				->addColumn(
					'product_id',
					\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					255,
					['nullable => false'],
					'Product ID'
				)
				->addColumn(
					'sku',
					\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					255,
					[],
					'SKU'
				)
				->addColumn(
					'serial_number',
					\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					'50',
					[],
					'Serial Number'
				)
				->addColumn(
					'status',
					\Magento\Framework\DB\Ddl\Table::TYPE_SMALLINT,
					null,
					[],
					'Usage Status'
				)
				->addColumn(
					'order_id',
					\Magento\Framework\DB\Ddl\Table::TYPE_TEXT,
					null,
					['nullable' => true, 'default'=>null],
					'Order ID'
				)
				->addColumn(
					'date_created',
					\Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP,
					null,
					['nullable' => false, 'default' => \Magento\Framework\DB\Ddl\Table::TIMESTAMP_INIT],
					'Date Created'
				)->addColumn(
					'date_updated',
					\Magento\Framework\DB\Ddl\Table::TYPE_TIMESTAMP,
					null,
					['nullable' => true],
					'Date Created')
				->setComment('Serial Numbers Table');
			$installer->getConnection()->createTable($table);

			$installer->getConnection()->addIndex(
				$installer->getTable('threepartment_serialnumbers_serialnumber'),
				$setup->getIdxName(
					$installer->getTable('threepartment_serialnumbers_serialnumber'),
					['sku', 'serial_number'],
					\Magento\Framework\DB\Adapter\AdapterInterface::INDEX_TYPE_UNIQUE
				),
				['sku', 'serial_number'],
				\Magento\Framework\DB\Adapter\AdapterInterface::INDEX_TYPE_UNIQUE
			);
		}
		$installer->endSetup();
	}
}